/**********************************************************
^C}荞ݏɓuԂ̏o
^C}荞݂1񂾂荞݂N
**********************************************************/
#include <3048f.h>
#include "h8_3048.h"

unsigned long int stackpointer; /*X^bN|C^̒lۑꏊ*/
unsigned char stack[0x30];      /*X^bN̈ۑꏊ*/

volatile int done=0; /*ŏ0荞ݏI1ɂȂ*/

void dumpStackBuffer(void)
{
	unsigned long int address=0xFFEF0;
	int i;
	SCI1_printf("address +0 +1 +2 +3 +4 +5 +6 +7 +8 +9 +A +B +C +D +E +F\n");
	for (i=0; i<0x30; i++,address++) {
		if (i%0x10==0) SCI1_printf ("%05lx : ",address);
		SCI1_printf("%02x ",stack[i]);
		if (i%0x10==0xf) SCI1_printf("\n");
	}
}


main()
{
	initLed();   /*LEDjbg̏@_ł邪CmFp*/
	initSCI1();  /*VAʐM̏*/
	SCI1_printf("\n\n\n  *** interrupt function starting demo ***\n\n");
	SCI1_printf("Check LEDs. If you see LEDs are off, push [ENTER] key.\n");
	getCharSCI1();

	/*X^bN|C^̒lƃX^bN̈C̕ϐɕۑ@AZułȂƏȂ*/
#pragma asm
    mov.l er7, @_stackpointer       ;er7(SP)̒lC̕ϐstackpointerɊi[
                                    ;stackpointerC̕ϐstackpointer̃AhXӖ̂
                                    ;u@vāC̃AhX̎wꏊ̈ӖɂĂ
    mov.l #H'FFEF0, er0             ;er00xffef0i[
    mov.l #_stack,  er1             ;er1C̕ϐstack̃AhXi[
                                    ;Ȃ킿C̔zϐstack̐擪AhX
    mov.b #H'30:8,  r2h             ;r2h0x30i8bitlji[
    bra   la02
la01:
    mov.b @er0+,     r2l            ;er0̎wĂoCglr2lɊi[Čer0̒lP₷
    mov.b r2l,      @er1            ;r2l̒lCer1̎wĂAhXɕۑ
    inc.l #1,       er1             ;er1̒lP₷
    dec.b           r2h             ;r2h̒lP炷
la02:
    bne   la01                      ;ỎZʂ0łȂla01փWv
#pragma endasm

	SCI1_printf("Stack Area (main satrting)\n");
	dumpStackBuffer();
	SCI1_printf("StackPointer= %05lx\n\n", stackpointer);

	initTimer01Int(500); /*Ԋ荞500msec ITUch0,1gp*/
	E_INT();        /*CPU荞݋*/
	startTimer01();  /*Ԋ荞݃^C}X^[gch0,ch1*/

	while(!done); /*荞ݏI܂Ń[v*/

	/*X^bN|C^̒lƃX^bN̈C̕ϐɕۑ@AZułȂƏȂ*/
	/*ɂAZuvO̕Ɠ*/
#pragma asm
    mov.l er7, @_stackpointer
    mov.l #H'FFEF0, er0
    mov.l #_stack,  er1
    mov.b #H'30:8,  r2h
    bra   lb02
lb01:
    mov.b @er0+,     r2l
    mov.b r2l,      @er1
    inc.l #1,       er1
    dec.b           r2h
lb02:
    bne   lb01
#pragma endasm

	stopTimer01();   /*Ԋ荞݃^C}[Xgbvch0,ch1*/
	D_INT();         /*CPU荞݋֎~*/

	SCI1_printf("Stack Area (main terminating)\n");
	dumpStackBuffer();
	SCI1_printf("StackPointer= %05lx\n\n", stackpointer);

	SCI1_printf("Done!   Check LEDs. If LEDs are lightend, OK!!\n");
	while(1);     /*[v*/
}  /*end of main*/


/*̍ƂɂLED_荞ݏɓƂmF*/
void lightenLED()
{
	SCI1_printf("Turning on LEDs.\n");
	turnOnLed(0);
	turnOnLed(1);
}


void printSituation(void)
{
	SCI1_printf("Stack Area in interrupt routine\n");
	dumpStackBuffer();
	SCI1_printf("StackPointer= %05lx\n\n", stackpointer);
}


/*xNge[u̐ݒ*/
#pragma asm
    .SECTION    MYVEC, DATA, LOCATE=H'000070
    .ORG        H'000070  ;IMIA1
    .DATA.L     _TimerIntFunction
    .SECTION    P,CODE,ALIGN=2 ;YĂ͂Ȃ
#pragma endasm

#pragma asm
_TimerIntFunction:                   ; function: _TimerIntFunction()
    ;X^bN|C^̒lƃX^bN̈C̕ϐɕۑ
    ;{Ȃ񊄂荞݃[`͂dĂ͂Ȃ̂ŁCer0Ȃǂ̃WX^
    ;gpłC荞݃[`ł̃WX^𗘗pꍇ́CWX^
    ;eX^bNɑޔC荞݃[`IOɕÂʂ̎głB
    ;{vOł́Cmain֐͉ƂĂȂ̂ŁCWX^ޔsĂȂB

    ;̕͏ɂAZuvO̕Ɠ

    mov.l er7, @_stackpointer;
    mov.l #H'FFEF0, er0
    mov.l #_stack,  er1
    mov.b #H'30:8,  r2h
    bra   lx02
lx01:
    mov.b @er0+,     r2l
    mov.b r2l,      @er1
    inc.l #1,       er1
    dec.b           r2h
lx02:
    bne   lx01

    ;  ۑX^bN|C^̒lƃX^bN̈\  
    jsr @_printSituation

    ;  ɗ؋LED_  
    jsr @_lightenLED

    ;  荞ݏƂmainɒm点
    mov.w  #1, r0
    mov.w  r0, @_done             ;C̕ϐdone1

    ;^C}jbgɊ荞݂󂯕tƂm点
    BCLR.B #0,@H'FFFF71:8         ;ITU1.TSR.BIT.IMFA=0;

    rte                    ; ReTurn from Exception
#pragma endasm

/*
s
NLEDĂ̂mFCEnterKeyƁCɐiňȉ
悤ɂȂĎ~܂悤ɌB

  *** interrupt function starting demo ***

Check LEDs. If you see LEDs are off, push [ENTER] key.

Stack Area (main satrting)
address +0 +1 +2 +3 +4 +5 +6 +7 +8 +9 +A +B +C +D +E +F
ffef0 : 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
fff00 : 00 00 00 00 00 00 0a 3c 00 00 0a 42 00 00 01 56
fff10 : ff ff ff ff ff ff ff ff ff ff ff ff 7f 00 00 00
StackPointer= fff0c

Stack Area in interrupt routine
address +0 +1 +2 +3 +4 +5 +6 +7 +8 +9 +A +B +C +D +E +F
ffef0 : 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
fff00 : 00 00 0a 94 00 00 0d 52 04 00 0a b0 00 00 01 56
fff10 : ff ff ff ff ff ff ff ff ff ff ff ff 7f 00 00 00
StackPointer= fff08

Turning on LEDs.
Stack Area (main terminating)
address +0 +1 +2 +3 +4 +5 +6 +7 +8 +9 +A +B +C +D +E +F
ffef0 : 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
fff00 : 00 00 00 00 00 00 0b a2 04 00 0a b0 00 00 01 56
fff10 : ff ff ff ff ff ff ff ff ff ff ff ff 7f 00 00 00
StackPointer= fff0c

Done!   Check LEDs. If LEDs are lightend, OK!!
*/

/* map
_main                                H'00000A16           DAT
_printSituation                      H'00000B42           DAT

*/
